// BufferConverter.h: interface for the CBufferConverter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BUFFERCONVERTER_H__9B567BC9_5E2D_49D4_8325_F73F1AD9638E__INCLUDED_)
#define AFX_BUFFERCONVERTER_H__9B567BC9_5E2D_49D4_8325_F73F1AD9638E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "common_definitions.h"
#undef RGB
#include "topfieldAPI\tap.h"

/*

  BufferConverter:

  .) maps a topfield pointer to a pc pointer (using long compare)
  .) copies and translates buffer   PC <-> topfield

*/



class CBufferConverter  
{
public:
	CBufferConverter();
	virtual ~CBufferConverter();


	// checks if found and returns pointer
	LONG GetTopfieldPointer(LONG pc);
	LONG GetPCPointer(LONG topfield);
	void AddPointer(LONG pc, LONG topfield);
	void RemoveTopfieldPointer(LONG topfield);
	void RemovePCPointer(LONG pc);
	
	void SwapWord(WORD *w);
	void SwapLong(LONG *w);
	void SwapULong64(ulong64 *w);


	void Convert_TYPE_OsdBaseInfo(TYPE_OsdBaseInfo *c);
	void Convert_TYPE_GrData(TYPE_GrData *c);
	void Convert_TYPE_TapChInfo(TYPE_TapChInfo *c);
	void Convert_TYPE_TapEvent(TYPE_TapEvent *c);
	void Convert_TYPE_VideoBank(TYPE_VideoBank *c);
	void Convert_TYPE_TimerInfo(TYPE_TimerInfo *c);
	void Convert_TYPE_File(TYPE_File *c);
	void Convert_TYPE_WindowColor(TYPE_WindowColor *c);
	void Convert_TYPE_Win(TYPE_Win *c);
	void Convert_TYPE_Window(TYPE_Window *c);


	CDWordArray				m_dwarrTopfield;
	CDWordArray				m_dwarrPC;
};

#endif // !defined(AFX_BUFFERCONVERTER_H__9B567BC9_5E2D_49D4_8325_F73F1AD9638E__INCLUDED_)
