/*

Topfield main program for simulation / debugging engine

*/



static int _exitFlag = 0;
static int _epgShow = 0;
static word rgn;

void DrawLine( word rgn, int Ax, int Ay, int Bx, int By, int Color );

int _curIdx, _topIdx, _bottomIdx;
int _height;
TYPE_TapEvent *_evtInfo;
WORD _svcType, _svcNum, _eventNum;
WORD _maxSvcNum;

static word mjd;
static byte time_h, time_min, time_sec, last_sec, refresh=0, refresh_sec=0;

char _strBuf[40];

#define X	 80
#define Y	 80
#define W	560
#define H	500
#define y_line	 36

#define titlebox_color COLOR_User13	// defaults: original: COLOR_User13 , Jag: COLOR_User13
#define font1_color COLOR_User13	// defaults: original: COLOR_Black , Jag: COLOR_User13
#define font2_color COLOR_User13	// defaults: original: COLOR_Black , Jag: COLOR_User13
#define box1_color RGB8888(90,115,155)	// defaults: original: COLOR_User11, Jag: RGB8888(90,115,155)
#define box2_color RGB8888(70,90,145)	// defaults: original: COLOR_User8 , Jag: RGB8888(70,90,145)
#define fineline_color COLOR_User9	// defaults: original: COLOR_User12 , Jag: COLOR_User9

#define MAX_LIST	10

void DrawTime( void )
{

	TAP_GetTime(&mjd, &time_h, &time_min, &time_sec);
	if (last_sec != time_sec)
	{
		TAP_SPrint( _strBuf, "  %02d:%02d:%02d  ", time_h, time_min, time_sec);
		TAP_Osd_PutStringAf1926( rgn, X+445, Y+6, X+W-4, _strBuf, COLOR_DarkCyan, titlebox_color);
		last_sec = time_sec;
	}
}

void GetEvent(	int svcType, int svcNum )
{
	int i;

	if( _evtInfo )
	{
		TAP_MemFree( _evtInfo );
		_evtInfo = 0;
	}

	_evtInfo = TAP_GetEvent( svcType, svcNum, &_eventNum );

	_curIdx = 0;
	for( i=0; i<_eventNum; i++ )
	{
		if( _evtInfo[i].runningStatus == 4 )
		{
			_curIdx = i;
			break;
		}
	}

	if( _eventNum < MAX_LIST )
		_topIdx = 0;
	else
		_topIdx = _curIdx;
	_bottomIdx = _topIdx + (MAX_LIST-1);
	if( _bottomIdx >= _eventNum )
		_bottomIdx = _eventNum - 1;

}

void DrawItem( int idx )
{
	int y;
	dword fc, bc;

	y = y_line+1 + (idx-_topIdx)*y_line;

	if( idx==_curIdx )
	{
		y+=3;
		fc = font1_color;
		bc = box1_color;
	}
	else
	{
		y+=3;
		fc = font2_color;
		bc = box2_color;
	}
	TAP_SPrint( _strBuf, " %02d:%02d - %02d:%02d",
		(_evtInfo[idx].startTime>>8)&0xff,_evtInfo[idx].startTime&0xff,
		(_evtInfo[idx].endTime>>8)&0xff,_evtInfo[idx].endTime&0xff );
	TAP_Osd_PutString1926( rgn, X+2, Y+y+2, X+140, _strBuf, fc, bc );
	TAP_Osd_PutString1926( rgn, X+140+4, Y+y+2, X+W-4, "    ", fc, bc );
	TAP_Osd_PutString1926( rgn, X+140+10, Y+y+2, X+W-4, _evtInfo[idx].eventName, fc, bc );
	y+=(y_line-3);
}

void DrawEvent( void )
{
	int i;
	for( i=_topIdx; i<=_bottomIdx; i++ )
	{
		DrawItem( i );
	}
}


int TAP_Main(void)
{
#if 0
	LONG p1, p2;
	WORD rgn;
	char s[200];
//	TYPE_TapChInfo *topf, *pc=NULL;

//	TAP_SPrint(s, "%d %s %f", 34, "sxchas", 3.1415);
//	TRACE("sizeof(TYPE_TapChInfo) = %d\n", sizeof(TYPE_TapChInfo));
//
//	topf = (TYPE_TapChInfo*)TAP_MemAlloc(sizeof(TYPE_TapChInfo));
//	pc = (TYPE_TapChInfo*)malloc(sizeof(TYPE_TapChInfo));
//	glob_memory.AddPointer((LONG)pc, (LONG)topf);
//
//
//	TAP_Channel_GetFirstInfo(SVC_TYPE_Tv, (TYPE_TapChInfo*)glob_memory.GetTopfieldPointer((LONG)pc));
//	TAP_Debug_BufferT2P(pc, glob_memory.GetTopfieldPointer((LONG)pc), sizeof(TYPE_TapChInfo));


	TYPE_TapChInfo local;
	memset(&local, sizeof(local), 0);
	TAP_Channel_GetFirstInfo(SVC_TYPE_Tv, &local);


	TAP_GetState(&p1, &p2);

	TAP_ExitNormal();
	rgn = TAP_Osd_Create( 70, 150, 300, 260, 0, FALSE );

	/*
	for (int x = 0; x < 10; x++) {
		for (int y = 0; y < 10; y++) {
			TAP_Osd_PutPixel(rgn, x, y, 0xFEFEFEFE);
		}
		
	}
	*/
	
		
	//TAP_Osd_PutString(rgn, 10, 10, 250, "Hello Roland", COLOR_DarkYellow, COLOR_Red, 0, FNT_Size_1622, 0 );
	TAP_SPrint(s, "Channel: %s, %s", local.chName, local.satName);
	TAP_Osd_PutString(rgn, 10, 10, 250, s, COLOR_DarkYellow, COLOR_Red, 0, FNT_Size_1622, 0 );

	TAP_Osd_Delete(rgn);

	TAP_EnterNormal();
#endif

	WORD r, t;
 	TAP_ExitNormal();
	rgn = TAP_Osd_Create( 0, 0, 720, 576, 0, FALSE );
	TAP_Channel_GetCurrent( &_svcType, &_svcNum );
	TAP_Channel_GetTotalNum( &t, &r );
	if( _svcType == SVC_TYPE_Tv )
		_maxSvcNum = t;
	else
		_maxSvcNum = r;
			
			
	int i, y;
	TYPE_TapChInfo chInfo;

	GetEvent( _svcType, _svcNum );

	TAP_Osd_FillBox( rgn, X, Y, W, y_line+7, titlebox_color );

	y = y_line+1;
	for( i=0; i<10; i++ )
	{
		TAP_Osd_FillBox( rgn, X, Y+y, W, 3, fineline_color );	//  duenne Linien waagerecht
		TAP_Osd_FillBox( rgn, X, Y+y+1, W, 1, fineline_color );	//  duenne Linien waagerecht 2
		y+=3;
		TAP_Osd_FillBox( rgn, X, Y+y, W, y_line-3, box2_color );
		y+=(y_line-3);
	}
	TAP_Osd_FillBox( rgn, X+140, Y+y_line+1, 2, y-(y_line+1), fineline_color );  // Linie senkrecht

	TAP_Osd_DrawRectangle( rgn, X, Y, W, y, 1, fineline_color );        // Auenlinie rundum
	TAP_Osd_DrawRectangle( rgn, X-1, Y-1, W+2, y+2, 1, fineline_color );     // Auenlinie rundum 2
	TAP_Osd_FillBox( rgn, X+W+1, Y+10, 10, y, COLOR_User1 );
	TAP_Osd_FillBox( rgn, X+10, Y+y+1, W, 10, COLOR_User1 );

	TAP_Osd_PutStringAf1926( rgn, X+5, Y+6, -1, "Quick EPG", COLOR_DarkBlue, COLOR_None );

	TAP_Channel_GetInfo( _svcType, _svcNum, &chInfo );
	TAP_SPrint( _strBuf, " %d. %s", _svcNum+1, chInfo.chName);
	TAP_Osd_PutStringAf1926( rgn, X+145, Y+6, X+W-4, _strBuf, COLOR_DarkCyan, COLOR_None );

	DrawEvent();
	last_sec = 99;


	TAP_Osd_Delete(rgn);

	TAP_EnterNormal();
	

	return 0;
}