// -- DEBUG FUNCTIONS - ROLAND
#define CTAP_Debug_BufferT2P			9999
#define CTAP_Debug_BufferP2T			9998
#define CTAP_Debug_QuitDebugger			9997
#define CTAP_Debug_StringP2T			9996
#define CTAP_Debug_StringT2P			9995

// -- SYSTEM FUNCTION ---------------------------------------------------
#define CTAP_SystemProc	1
#define CTAP_GetState 2
#define CTAP_ExitNormal 3
#define CTAP_EnterNormal 4	
#define CTAP_Exit 5

#define CTAP_KbHit 6
#define CTAP_GetCh 7
#define CTAP_PutCh 8
#define CTAP_Print 9

// -- COMMON FUNCTION ---------------------------------------------------
#define CTAP_SetSoundLevel 10
#define CTAP_GetTime 11
#define CTAP_MemInfo 12
#define CTAP_MemAlloc 13
#define CTAP_MemFree 14
#define CTAP_GetTick 15
#define CTAP_Delay 16
#define CTAP_ExtractMjd 17
#define CTAP_MakeMjd 18
#define CTAP_Sin 19
#define CTAP_Cos 20
#define CTAP_SPrint 21
#define CTAP_GetSignalLevel 22
#define CTAP_GetSignalQuality 23
#define CTAP_SetInfoboxTime 24
#define CTAP_PlayPCM 25
#define CTAP_CaptureScreen 26

#define CTAP_SetSystemVar 27
#define CTAP_GetSystemVar 28
#define CTAP_WriteSystemVar 29
#define CTAP_GenerateEvent 30

// -- OSD FUNCTION ---------------------------------------------------
#define CTAP_Osd_Create 31
#define CTAP_Osd_Delete 32
#define CTAP_Osd_Move 33
#define CTAP_Osd_FillBox 34
#define CTAP_Osd_PutBox 35
#define CTAP_Osd_GetBox 36
#define CTAP_Osd_SetLut 37
#define CTAP_Osd_Ctrl 38
#define CTAP_Osd_SetTransparency 39

#define CTAP_Osd_Draw3dBox 40
#define CTAP_Osd_Draw3dBoxFill 41

#define CTAP_Osd_DrawRectangle 42
#define CTAP_Osd_DrawPixmap 43
#define CTAP_Osd_Zoom 44
#define CTAP_Osd_GetBaseInfo 45
#define CTAP_Osd_Copy 46
//#define CTAP_Osd_PutGd__
#define CTAP_Osd_PutGd 47

#define CTAP_Osd_SaveBox 48
#define CTAP_Osd_RestoreBox 49

#define CTAP_Osd_GetPixel 50
#define CTAP_Osd_PutPixel 51

// -- HDD FUNCTION ---------------------------------------------------

#define CTAP_Hdd_Fopen 52
#define CTAP_Hdd_Fread 53
#define CTAP_Hdd_Fwrite 54
#define CTAP_Hdd_Fclose 55
#define CTAP_Hdd_FindFirst 56
#define CTAP_Hdd_FindNext 57
#define CTAP_Hdd_Fseek 58
#define CTAP_Hdd_Flen 59
#define CTAP_Hdd_Ftell 60
#define CTAP_Hdd_TotalSize 61
#define CTAP_Hdd_FreeSize 62
#define CTAP_Hdd_Delete 63
#define CTAP_Hdd_Exist 64
#define CTAP_Hdd_Create 65
#define CTAP_Hdd_ChangeDir 66

#define CTAP_Hdd_PlayTs 67
#define CTAP_Hdd_StopTs 68
#define CTAP_Hdd_PlayMp3 69
#define CTAP_Hdd_StopMp3 70
#define CTAP_Hdd_Rename 71


// -- STRING FUNCTION ---------------------
#define CTAP_Osd_PutS 72
#define CTAP_Osd_GetW 73
#define CTAP_Osd_PutString 74
#define CTAP_Osd_DrawString 75
#define CTAP_Osd_PutStringAf 76

// -- WINDOW FUNCTION ---------------------------------------------------
#define CTAP_Win_SetTitle 77
#define CTAP_Win_SetColor 78
#define CTAP_Win_SetDefaultColor 79
#define CTAP_Win_Draw 80
#define CTAP_Win_Create 81
#define CTAP_Win_Delete 82
#define CTAP_Win_SetFont 83
#define CTAP_Win_AddItem 84
#define CTAP_Win_GetSelection 85
#define CTAP_Win_SetSelection 86
#define CTAP_Win_Action 87

// ---------------------------------------------------------------------

#define CTAP_Channel_GetTotalNum 88
#define CTAP_Channel_GetFirstInfo 89
#define CTAP_Channel_GetNextInfo 90
#define CTAP_Channel_GetInfo 91
#define CTAP_Channel_GetCurrent 92
#define CTAP_Channel_Start 93
#define CTAP_Channel_Scale 94
#define CTAP_Channel_IsPlayable 95
#define CTAP_Channel_Move 96
#define CTAP_Channel_Stop 97
#define CTAP_Channel_GetTotalAudioTrack 98
#define CTAP_Channel_GetAudioTrackName 99
#define CTAP_Channel_SetAudioTrack 100
#define CTAP_Channel_GetTotalSubtitleTrack 101
#define CTAP_Channel_GetSubtitleTrackName 102
#define CTAP_Channel_SetSubtitleTrack 103

#define CTAP_GetEvent 104
#define CTAP_GetCurrentEvent 105

// --- USB FUNCTIONS ---------------------------------------------------

#define CTAP_Usb_Read 106
#define CTAP_Usb_Write 107
#define CTAP_Usb_PacketRead 108
#define CTAP_Usb_PacketWrite 109
#define CTAP_Usb_Cancel 110

// --- TIMER FUNCTIONS ---------------------------------------------------

#define CTAP_Timer_GetTotalNum 111
#define CTAP_Timer_GetInfo 112
#define CTAP_Timer_Add 113
#define CTAP_Timer_Modify 114
#define CTAP_Timer_Delete 115

